using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace People.Types.GeneratedTypes
{
    public partial class Person
    {
        public Address Address = new Address();

        protected override void OnInitializeComplete()
        {
            // Load the address. 
            if (AddressId != null && AddressId != Guid.Empty)
            {
                Address = new Address();
                Address.Load(AddressId.GetValueOrDefault());
            }

            base.OnInitializeComplete();
        } 

        protected override void OnSave()
        {
            CreateDate = DateTime.Now;

            if (Address.IsDirty)
            {
                // Save the address. 
                Address.Save();

                // Fill in our foreign key. 
                AddressId = Address.AddressId;
            } 

            base.OnSave();
        }
    }
}
