using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

/*
Primary Objects Linquify - Business Class Generator
Copyright (C) 2010 Kory Becker
http://www.primaryobjects.com

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.
*/

namespace People.Types.GeneratedTypes
{
    [Serializable]
    public partial class Address : People.Types.GeneratedTypes.BaseTypes.Address
    {
		public Address()
		{
		}

		public Address(People.Types.GeneratedTypes.BaseTypes.Address address)
		{
			AddressId = address.AddressId;
			City = address.City;
			State = address.State;
			Street = address.Street;

			OnInitializeComplete();
		}
		
        public Address(System.Nullable<System.Guid> _AddressId, string _City, string _State, string _Street)
        {
            if (_AddressId != null)
            {
                AddressId = (System.Guid)_AddressId;
            }

			City = _City;
			State = _State;
			Street = _Street;

        }
		
        public new List<Address> Find()
        {
            List<Address> finalResults = new List<Address>();

            List<People.Types.GeneratedTypes.BaseTypes.Address> results = base.Find();

            return ConvertFromBaseTypes(results);
        }		

        public new List<Address> ToList()
        {
            List<Address> finalResults = new List<Address>();

            List<People.Types.GeneratedTypes.BaseTypes.Address> results = base.ToList();

            return ConvertFromBaseTypes(results);
        }
        
        private List<Address> ConvertFromBaseTypes(List<People.Types.GeneratedTypes.BaseTypes.Address> baseTypeList)
        {
			List<Address> typeList = new List<Address>();
			
            foreach (People.Types.GeneratedTypes.BaseTypes.Address baseType in baseTypeList)
            {
                typeList.Add(new Address(baseType));
            }
            
            return typeList;
        }
    }
}
